## lmms 0.4.10

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.4.5)

PROJECT(lmms)

SET(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules ${CMAKE_MODULE_PATH})

IF(COMMAND CMAKE_POLICY)
	CMAKE_POLICY(SET CMP0005 NEW)
	CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

INCLUDE(AddFileDependencies)
INCLUDE(CheckIncludeFiles)
INCLUDE(FindPkgConfig)

SET(VERSION_MAJOR "0")
SET(VERSION_MINOR "4")
SET(VERSION_PATCH "10")
#SET(VERSION_SUFFIX "")
SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
IF(VERSION_SUFFIX)
	SET(VERSION "${VERSION}-${VERSION_SUFFIX}")
ENDIF(VERSION_SUFFIX)


INCLUDE(DetectMachine)


OPTION(WANT_ALSA	"Include ALSA (Advanced Linux Sound Architecture) support" ON)
OPTION(WANT_CALF	"Include CALF LADSPA plugins" ON)
OPTION(WANT_CAPS	"Include C* Audio Plugin Suite (LADSPA plugins)" ON)
OPTION(WANT_CMT		"Include Computer Music Toolkit LADSPA plugins" ON)
OPTION(WANT_FFTW3F	"Include SpectrumAnalyzer and ZynAddSubFX plugin" ON)
OPTION(WANT_JACK	"Include JACK (Jack Audio Connection Kit) support" ON)
OPTION(WANT_OGGVORBIS	"Include OGG/Vorbis support" ON)
OPTION(WANT_PULSEAUDIO	"Include PulseAudio support" ON)
OPTION(WANT_PORTAUDIO	"Include PortAudio support" ON)
OPTION(WANT_SDL		"Include SDL (Simple DirectMedia Layer) support" ON)
OPTION(WANT_SF2		"Include SoundFont2 player plugin" ON)
OPTION(WANT_STK		"Include Stk (Synthesis Toolkit) support" ON)
OPTION(WANT_SYSTEM_SR	"Use system's libsamplerate" ON)
OPTION(WANT_SWH		"Include Steve Harris's LADSPA plugins" ON)
OPTION(WANT_TAP		"Include Tom's Audio Processing LADSPA plugins" ON)
OPTION(WANT_VST		"Include VST support" ON)
OPTION(WANT_VST_NOWINE	"Include partial VST support (without wine)" OFF)
OPTION(WANT_WINMM	"Include WinMM MIDI support" OFF)

IF(LMMS_BUILD_WIN32)
	SET(WANT_ALSA OFF)
	SET(WANT_JACK OFF)
	SET(WANT_PULSEAUDIO OFF)
	SET(WANT_SYSTEM_SR OFF)
	SET(WANT_WINMM ON)
	SET(LMMS_HAVE_WINMM TRUE)
	SET(STATUS_ALSA "<not supported on this platform>")
	SET(STATUS_JACK "<not supported on this platform>")
	SET(STATUS_PULSEAUDIO "<not supported on this platform>")
	SET(STATUS_WINMM "OK")
ELSE(LMMS_BUILD_WIN32)
	SET(STATUS_WINMM "<not supported on this platform>")
ENDIF(LMMS_BUILD_WIN32)



CHECK_INCLUDE_FILES(stdint.h LMMS_HAVE_STDINT_H)
CHECK_INCLUDE_FILES(stdlib.h LMMS_HAVE_STDLIB_H)
CHECK_INCLUDE_FILES(pthread.h LMMS_HAVE_PTHREAD_H)
CHECK_INCLUDE_FILES(semaphore.h LMMS_HAVE_SEMAPHORE_H)
CHECK_INCLUDE_FILES(unistd.h LMMS_HAVE_UNISTD_H)
CHECK_INCLUDE_FILES(sys/types.h LMMS_HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES(sys/ipc.h LMMS_HAVE_SYS_IPC_H)
CHECK_INCLUDE_FILES(sys/shm.h LMMS_HAVE_SYS_SHM_H)
CHECK_INCLUDE_FILES(sys/time.h LMMS_HAVE_SYS_TIME_H)
CHECK_INCLUDE_FILES(sys/wait.h LMMS_HAVE_SYS_WAIT_H)
CHECK_INCLUDE_FILES(sys/select.h LMMS_HAVE_SYS_SELECT_H)
CHECK_INCLUDE_FILES(stdarg.h LMMS_HAVE_STDARG_H)
CHECK_INCLUDE_FILES(signal.h LMMS_HAVE_SIGNAL_H)
CHECK_INCLUDE_FILES(sched.h LMMS_HAVE_SCHED_H)
CHECK_INCLUDE_FILES(sys/soundcard.h LMMS_HAVE_SYS_SOUNDCARD_H)
CHECK_INCLUDE_FILES(soundcard.h LMMS_HAVE_SOUNDCARD_H)
CHECK_INCLUDE_FILES(fcntl.h LMMS_HAVE_FCNTL_H)
CHECK_INCLUDE_FILES(sys/ioctl.h LMMS_HAVE_SYS_IOCTL_H)
CHECK_INCLUDE_FILES(ctype.h LMMS_HAVE_CTYPE_H)
CHECK_INCLUDE_FILES(string.h LMMS_HAVE_STRING_H)
CHECK_INCLUDE_FILES(process.h LMMS_HAVE_PROCESS_H)
CHECK_INCLUDE_FILES(locale.h LMMS_HAVE_LOCALE_H)

# check for Qt4
SET(QT_MIN_VERSION "4.3.0" COMPONENTS QtCore QtGui QtXml)
FIND_PACKAGE(Qt4 REQUIRED)
SET(QT_USE_QTXML 1)
EXEC_PROGRAM(${QT_QMAKE_EXECUTABLE} ARGS "-query QT_INSTALL_TRANSLATIONS" OUTPUT_VARIABLE QT_TRANSLATIONS_DIR)
IF(WIN32)
	SET(QT_TRANSLATIONS_DIR "${MINGW_PREFIX}/share/qt4/translations/")
ENDIF(WIN32)
IF(EXISTS "${QT_TRANSLATIONS_DIR}")
	MESSAGE("-- Found Qt translations in ${QT_TRANSLATIONS_DIR}")
	ADD_DEFINITIONS(-D'QT_TRANSLATIONS_DIR="${QT_TRANSLATIONS_DIR}"')
ENDIF(EXISTS "${QT_TRANSLATIONS_DIR}")
IF(NOT WIN32)
	STRING(REPLACE "-DQT_DLL" "" QT_DEFINITIONS "${QT_DEFINITIONS}")
ENDIF(NOT WIN32)
INCLUDE(${QT_USE_FILE})

# check for libsndfile
PKG_CHECK_MODULES(SNDFILE REQUIRED sndfile>=1.0.11)
IF(NOT SNDFILE_FOUND)
	MESSAGE(FATAL_ERROR "LMMS requires libsndfile1 and libsndfile1-dev >= 1.0.11 - please install, remove CMakeCache.txt and try again!")
ENDIF(NOT SNDFILE_FOUND)

IF(WANT_CALF)
SET(LMMS_HAVE_CALF TRUE)
SET(STATUS_CALF "OK")
ELSE(WANT_CALF)
SET(STATUS_CALF "not built as requested")
ENDIF(WANT_CALF)

IF(WANT_CAPS)
SET(LMMS_HAVE_CAPS TRUE)
SET(STATUS_CAPS "OK")
ELSE(WANT_CAPS)
SET(STATUS_CAPS "not built as requested")
ENDIF(WANT_CAPS)

IF(WANT_CMT)
SET(LMMS_HAVE_CMT TRUE)
SET(STATUS_CMT "OK")
ELSE(WANT_CMT)
SET(STATUS_CMT "not built as requested")
ENDIF(WANT_CMT)

IF(WANT_SWH)
SET(LMMS_HAVE_SWH TRUE)
SET(STATUS_SWH "OK")
ELSE(WANT_SWH)
SET(STATUS_SWH "not built as requested")
ENDIF(WANT_SWH)

IF(WANT_TAP)
SET(LMMS_HAVE_TAP TRUE)
SET(STATUS_TAP "OK")
ELSE(WANT_TAP)
SET(STATUS_TAP "not built as requested")
ENDIF(WANT_TAP)


# check for SDL
IF(WANT_SDL)
	SET(SDL_BUILDING_LIBRARY TRUE)
	FIND_PACKAGE(SDL)
	IF(SDL_FOUND)
		SET(LMMS_HAVE_SDL TRUE)
		SET(STATUS_SDL "OK")
	ELSE(SDL_FOUND)
		SET(STATUS_SDL "not found, please install libsdl1.2-dev (or similiar) "
			"if you require SDL support")
	ENDIF(SDL_FOUND)
ENDIF(WANT_SDL)
IF(NOT LMMS_HAVE_SDL)
	SET(SDL_INCLUDE_DIR "")
ELSE(NOT LMMS_HAVE_SDL)
	IF(NOT SDL_INCLUDE_DIR)
		SET(SDL_INCLUDE_DIR ${CMAKE_FIND_ROOT_PATH}/include)
	ENDIF(NOT SDL_INCLUDE_DIR)
ENDIF(NOT LMMS_HAVE_SDL)


# check for Stk
IF(WANT_STK)
	FIND_PACKAGE(STK)
	IF(STK_FOUND)
		SET(LMMS_HAVE_STK TRUE)
		SET(STATUS_STK "OK")
	ELSE(STK_FOUND)
		SET(STK_INCLUDE_DIR "")
		SET(STATUS_STK "not found, please install libstk0-dev (or similiar) "
			"if you require the Mallets instrument")
	ENDIF(STK_FOUND)
ENDIF(WANT_STK)


# check for PortAudio
IF(WANT_PORTAUDIO)
	FIND_PACKAGE(Portaudio)
	IF(PORTAUDIO_FOUND)
		SET(LMMS_HAVE_PORTAUDIO TRUE)
		SET(STATUS_PORTAUDIO "OK")
	ELSE(PORTAUDIO_FOUND)
		SET(STATUS_PORTAUDIO "not found, please install portaudio19-dev (or similiar, version >= 1.9) "
			"if you require PortAudio support")
	ENDIF(PORTAUDIO_FOUND)
ENDIF(WANT_PORTAUDIO)


# check for PulseAudio
IF(WANT_PULSEAUDIO)
	FIND_PACKAGE(PulseAudio)
	IF(PULSEAUDIO_FOUND)
		SET(LMMS_HAVE_PULSEAUDIO TRUE)
		SET(STATUS_PULSEAUDIO "OK")
	ELSE(PULSEAUDIO_FOUND)
		SET(STATUS_PULSEAUDIO "not found, please install libpulse-dev (or similiar) "
			"if you require PulseAudio support")
	ENDIF(PULSEAUDIO_FOUND)
ENDIF(WANT_PULSEAUDIO)
IF(NOT LMMS_HAVE_PULSEAUDIO)
	SET(PULSEAUDIO_INCLUDE_DIR "")
	SET(PULSEAUDIO_LIBRARIES "")
ENDIF(NOT LMMS_HAVE_PULSEAUDIO)


# check for OGG/Vorbis-libraries
IF(WANT_OGGVORBIS)
	FIND_PACKAGE(OggVorbis)
	IF(OGGVORBIS_FOUND)
		SET(LMMS_HAVE_OGGVORBIS TRUE)
		SET(STATUS_OGGVORBIS "OK")
	ELSE(OGGVORBIS_FOUND)
		SET(STATUS_OGGVORBIS "not found, libogg-dev and libvorbis-dev (or similiar) "
			"is highly recommended")
	ENDIF(OGGVORBIS_FOUND)
ENDIF(WANT_OGGVORBIS)


# check whether to enable OSS-support
IF(LMMS_HAVE_SOUNDCARD_H OR LMMS_HAVE_SYS_SOUNDCARD_H)
	SET(LMMS_HAVE_OSS TRUE)
	SET(STATUS_OSS "OK")
ELSE(LMMS_HAVE_SOUNDCARD_H OR LMMS_HAVE_SYS_SOUNDCARD_H)
	SET(STATUS_OSS "<not found or not supported on this platform>")
ENDIF(LMMS_HAVE_SOUNDCARD_H OR LMMS_HAVE_SYS_SOUNDCARD_H)


# check for ALSA
IF(WANT_ALSA)
	FIND_PACKAGE(Alsa)
	IF(ALSA_FOUND)
		SET(LMMS_HAVE_ALSA TRUE)
		SET(STATUS_ALSA "OK")
	ELSE(ALSA_FOUND)
		SET(STATUS_ALSA "not found, please install libasound2-dev (or similiar) "
			"if you require ALSA support")
	ENDIF(ALSA_FOUND)
ENDIF(WANT_ALSA)
IF(NOT LMMS_HAVE_ALSA)
	SET(ASOUND_LIBRARY "")
ENDIF(NOT LMMS_HAVE_ALSA)


# check for JACK
IF(WANT_JACK)
	PKG_CHECK_MODULES(JACK jack>=0.77)
	IF(JACK_FOUND)
		SET(LMMS_HAVE_JACK TRUE)
		SET(STATUS_JACK "OK")
	ELSE(JACK_FOUND)
		SET(STATUS_JACK "not found, please install libjack0.100.0-dev (or similiar) "
			"if you require JACK support")
	ENDIF(JACK_FOUND)
ENDIF(WANT_JACK)


# check for FFTW3F-library
IF(WANT_FFTW3F)
	PKG_CHECK_MODULES(FFTW3F fftw3f>=3.0.0)
	IF(FFTW3F_FOUND)
		SET(LMMS_HAVE_FFTW3F TRUE)
		SET(STATUS_FFTW3F "OK")
	ELSE(FFTW3F_FOUND)
		SET(STATUS_FFTW3F "not found, libfftw3-dev (or similiar) "
			"is highly recommended")
	ENDIF(FFTW3F_FOUND)
ENDIF(WANT_FFTW3F)


# check for Fluidsynth
IF(WANT_SF2)
	PKG_CHECK_MODULES(FLUIDSYNTH fluidsynth>=1.0.7)
	IF(FLUIDSYNTH_FOUND)
		SET(LMMS_HAVE_FLUIDSYNTH TRUE)
		SET(STATUS_FLUIDSYNTH "OK")
	ELSE(FLUIDSYNTH_FOUND)
		SET(STATUS_FLUIDSYNTH "not found, libfluidsynth-dev (or similiar)"
			"is highly recommended")
	ENDIF(FLUIDSYNTH_FOUND)
ENDIF(WANT_SF2)

# check for pthreads
IF(LMMS_BUILD_LINUX OR LMMS_BUILD_APPLE)
	FIND_PACKAGE(Threads)
ENDIF(LMMS_BUILD_LINUX OR LMMS_BUILD_APPLE)

# check for WINE
IF(WANT_VST)
	INCLUDE(CheckLibraryExists)
	INCLUDE(CheckIncludeFileCXX)
	SET(CMAKE_REQUIRED_FLAGS_ORIG ${CMAKE_REQUIRED_FLAGS})
	SET(CMAKE_REQUIRED_INCLUDES_ORIG ${CMAKE_REQUIRED_INCLUDES})
	SET(CMAKE_CXX_COMPILER_ORIG ${CMAKE_CXX_COMPILER})
	IF(LMMS_HOST_X86_64)
		SET(CMAKE_REQUIRED_FLAGS -m32 ${CMAKE_REQUIRED_FLAGS})
	ENDIF(LMMS_HOST_X86_64)
	CHECK_LIBRARY_EXISTS(wine wine_init "" HAVE_LIBWINE)
	SET(CMAKE_CXX_COMPILER /usr/bin/wineg++)
	SET(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${CMAKE_INSTALL_PREFIX}/include/wine/windows /usr/include/wine/windows)
	CHECK_INCLUDE_FILE_CXX(windows.h HAVE_WINDOWS_H)
	SET(CMAKE_CXX_COMPILER ${CMAKE_CXX_COMPILER_ORIG})
	SET(CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS_ORIG})
	SET(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES_ORIG})
	IF(HAVE_LIBWINE AND HAVE_WINDOWS_H)
		SET(LMMS_SUPPORT_VST TRUE)
		SET(STATUS_VST "OK")
	ELSE(HAVE_LIBWINE AND HAVE_WINDOWS_H)
		SET(STATUS_VST "not found, please install (lib)wine-dev (or similiar) - 64 bit systems additionally need gcc-multilib and g++-multilib")
	ENDIF(HAVE_LIBWINE AND HAVE_WINDOWS_H)
ENDIF(WANT_VST)
IF(LMMS_BUILD_WIN32)
	SET(LMMS_SUPPORT_VST TRUE)
	SET(STATUS_VST "OK")
ENDIF(LMMS_BUILD_WIN32)


# check for libsamplerate
IF(WANT_SYSTEM_SR)
	PKG_CHECK_MODULES(SAMPLERATE samplerate>=0.1.7)
	IF(SAMPLERATE_FOUND)
		SET(LMMS_HAVE_SAMPLERATE TRUE)
	ENDIF(SAMPLERATE_FOUND)
ENDIF(WANT_SYSTEM_SR)
IF(NOT LMMS_HAVE_SAMPLERATE)
	INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/src/3rdparty/samplerate)
	SET(CMAKE_CROSSCOMPILING_ORIG "${CMAKE_CROSSCOMPILING}")
	SET(CMAKE_CROSSCOMPILING "")
	INCLUDE(ChecksForLibSamplerate)
	SET(LIBSAMPLERATE_SOURCES 
		${CMAKE_SOURCE_DIR}/src/3rdparty/samplerate/samplerate.c
		${CMAKE_SOURCE_DIR}/src/3rdparty/samplerate/samplerate.h
		${CMAKE_SOURCE_DIR}/src/3rdparty/samplerate/src_sinc.c
		${CMAKE_SOURCE_DIR}/src/3rdparty/samplerate/high_qual_coeffs.h
		${CMAKE_SOURCE_DIR}/src/3rdparty/samplerate/mid_qual_coeffs.h
		${CMAKE_SOURCE_DIR}/src/3rdparty/samplerate/fastest_coeffs.h
		${CMAKE_SOURCE_DIR}/src/3rdparty/samplerate/common.h
		${CMAKE_SOURCE_DIR}/src/3rdparty/samplerate/src_config.h
		${CMAKE_SOURCE_DIR}/src/3rdparty/samplerate/float_cast.h
		${CMAKE_SOURCE_DIR}/src/3rdparty/samplerate/src_zoh.c
		${CMAKE_SOURCE_DIR}/src/3rdparty/samplerate/src_linear.c)
	SET(CMAKE_CROSSCOMPILING "${CMAKE_CROSSCOMPILING_ORIG}")
ENDIF(NOT LMMS_HAVE_SAMPLERATE)


CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/lmmsconfig.h.in ${CMAKE_BINARY_DIR}/lmmsconfig.h)
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/lmmsversion.h.in ${CMAKE_BINARY_DIR}/lmmsversion.h)
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/lmms.rc.in ${CMAKE_BINARY_DIR}/lmms.rc)
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/plugins/zynaddsubfx/zynaddsubfx.rc.in ${CMAKE_BINARY_DIR}/plugins/zynaddsubfx/zynaddsubfx.rc)

# set compiler flags
#SET(CMAKE_BUILD_TYPE relwithdebug)
SET(CMAKE_C_FLAGS "-O2 -g -Wall ${CMAKE_C_FLAGS}")
SET(CMAKE_CXX_FLAGS "-O2 -g -fno-exceptions -Wall ${CMAKE_CXX_FLAGS}")
#SET(CMAKE_C_FLAGS_${CMAKE_BUILD_TYPE} "${CMAKE_C_FLAGS}")
#SET(CMAKE_CXX_FLAGS_${CMAKE_BUILD_TYPE} "${CMAKE_CXX_FLAGS}")


# people simply updating SVN will still have this and mess up build with it
FILE(REMOVE include/lmmsconfig.h)

FILE(GLOB lmms_INCLUDES ${CMAKE_SOURCE_DIR}/include/*.h)
FILE(GLOB lmms_UI ${CMAKE_SOURCE_DIR}/src/gui/dialogs/*.ui ${CMAKE_SOURCE_DIR}/src/gui/Forms/*.ui)

=== plugins/CMakeLists.txt ===
ADD_SUBDIRECTORY(audio_file_processor)
ADD_SUBDIRECTORY(bass_booster)
ADD_SUBDIRECTORY(bit_invader)
ADD_SUBDIRECTORY(flp_import)
ADD_SUBDIRECTORY(kicker)
ADD_SUBDIRECTORY(ladspa_browser)
ADD_SUBDIRECTORY(ladspa_effect)
ADD_SUBDIRECTORY(lb302)
#ADD_SUBDIRECTORY(lb303)
ADD_SUBDIRECTORY(midi_import)
ADD_SUBDIRECTORY(organic)
ADD_SUBDIRECTORY(papu)
ADD_SUBDIRECTORY(patman)
ADD_SUBDIRECTORY(peak_controller_effect)
ADD_SUBDIRECTORY(sf2_player)
ADD_SUBDIRECTORY(sid)
ADD_SUBDIRECTORY(spectrum_analyzer)
ADD_SUBDIRECTORY(stereo_enhancer)
ADD_SUBDIRECTORY(stereo_matrix)
ADD_SUBDIRECTORY(stk)
ADD_SUBDIRECTORY(triple_oscillator)
ADD_SUBDIRECTORY(vestige)
ADD_SUBDIRECTORY(vst_base)
ADD_SUBDIRECTORY(vst_effect)
ADD_SUBDIRECTORY(vibed)
ADD_SUBDIRECTORY(zynaddsubfx)

=== data/projects/CMakeLists.txt ===
INCLUDE(InstallHelpers)

INSTALL_DATA_SUBDIRS("projects" "*.mmp")
INSTALL_DATA_SUBDIRS("projects" "*.mmpz")

=== plugins/bit_invader/CMakeLists.txt ===
INCLUDE(BuildPlugin)

BUILD_PLUGIN(bitinvader bit_invader.cpp bit_invader.h MOCFILES bit_invader.h EMBEDDED_RESOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.png)

=== plugins/kicker/CMakeLists.txt ===
INCLUDE(BuildPlugin)

BUILD_PLUGIN(kicker kicker.cpp kicker.h MOCFILES kicker.h EMBEDDED_RESOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.png)

=== plugins/ladspa_effect/CMakeLists.txt ===
IF(WANT_CAPS)
ADD_SUBDIRECTORY(caps)
ENDIF(WANT_CAPS)

IF(WANT_TAP)
ADD_SUBDIRECTORY(tap)
ENDIF(WANT_TAP)

IF(WANT_SWH)
ADD_SUBDIRECTORY(swh)
ENDIF(WANT_SWH)

IF(WANT_CMT)
ADD_SUBDIRECTORY(cmt)
ENDIF(WANT_CMT)

IF(WANT_CALF)
ADD_SUBDIRECTORY(calf)
ENDIF(WANT_CALF)


INCLUDE(BuildPlugin)

BUILD_PLUGIN(ladspaeffect LadspaEffect.cpp LadspaControls.cpp LadspaControlDialog.cpp LadspaSubPluginFeatures.cpp LadspaEffect.h LadspaControls.h LadspaControlDialog.h LadspaSubPluginFeatures.h MOCFILES LadspaEffect.h LadspaControls.h LadspaControlDialog.h EMBEDDED_RESOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.png)

=== plugins/midi_import/CMakeLists.txt ===
INCLUDE(BuildPlugin)

BUILD_PLUGIN(midiimport MidiImport.cpp MidiImport.h
	portsmf/allegro.cpp portsmf/allegro.h portsmf/allegrosmfwr.cpp
	portsmf/allegrord.cpp portsmf/allegrowr.cpp portsmf/allegrosmfrd.cpp
	portsmf/mfmidi.cpp portsmf/mfmidi.h portsmf/strparse.cpp
	portsmf/strparse.h portsmf/algrd_internal.h portsmf/algsmfrd_internal.h
	portsmf/trace.h)

=== plugins/sid/CMakeLists.txt ===
INCLUDE(BuildPlugin)

BUILD_PLUGIN(sid sid_instrument.cpp sid_instrument.h envelope.h extfilt.h filter.h pot.h siddefs.h sid.h spline.h voice.h wave.h envelope.cc extfilt.cc filter.cc pot.cc sid.cc version.cc voice.cc wave6581_PS_.cc wave6581_PST.cc wave6581_P_T.cc wave6581__ST.cc wave8580_PS_.cc wave8580_PST.cc wave8580_P_T.cc wave8580__ST.cc wave.cc  MOCFILES sid_instrument.h EMBEDDED_RESOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.png)

=== plugins/vst_base/CMakeLists.txt ===
IF(LMMS_SUPPORT_VST)

INCLUDE(BuildPlugin)

IF(LMMS_BUILD_WIN32)
	ADD_DEFINITIONS(-DPTW32_STATIC_LIB)
	LINK_LIBRARIES(-lQtCore4 -lpthread -lgdi32 -lws2_32)
	ADD_EXECUTABLE(RemoteVstPlugin ${CMAKE_CURRENT_SOURCE_DIR}/RemoteVstPlugin.cpp)
	ADD_CUSTOM_COMMAND(TARGET RemoteVstPlugin POST_BUILD COMMAND ${STRIP} ${CMAKE_CURRENT_BINARY_DIR}/RemoteVstPlugin.exe)
	INSTALL(TARGETS RemoteVstPlugin RUNTIME DESTINATION ${PLUGIN_DIR})

	IF(LMMS_BUILD_WIN64)
		# build 32 bit version of RemoteVstPlugin for Win64 so we can load
		# 32 bit VST plugins
		ADD_SUBDIRECTORY(Win64)
	ENDIF(LMMS_BUILD_WIN64)
ENDIF(LMMS_BUILD_WIN32)

BUILD_PLUGIN(vstbase vst_base.cpp VstPlugin.cpp VstPlugin.h communication.h MOCFILES VstPlugin.h)


IF(LMMS_BUILD_LINUX AND NOT WANT_VST_NOWINE)

IF(LMMS_HOST_X86_64)
	SET(EXTRA_FLAGS -m32)
ENDIF(LMMS_HOST_X86_64)
ADD_CUSTOM_COMMAND(
		SOURCE ${CMAKE_CURRENT_SOURCE_DIR}/RemoteVstPlugin.cpp
		COMMAND wineg++
		ARGS -I${CMAKE_BINARY_DIR} -I${CMAKE_SOURCE_DIR}/include -I${CMAKE_INSTALL_PREFIX}/include/wine/windows -I${CMAKE_INSTALL_PREFIX}/include -I/usr/include/wine/windows ${CMAKE_CURRENT_SOURCE_DIR}/RemoteVstPlugin.cpp -mwindows -lpthread ${EXTRA_FLAGS} -o RemoteVstPlugin
		COMMAND find -name RemoteVstPlugin.exe -exec mv "'{}'" RemoteVstPlugin "';'"
		TARGET vstbase
		OUTPUTS RemoteVstPlugin
		)

SET_DIRECTORY_PROPERTIES(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES RemoteVstPlugin.exe.so)

INSTALL(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/RemoteVstPlugin ${CMAKE_CURRENT_BINARY_DIR}/RemoteVstPlugin.exe.so DESTINATION ${PLUGIN_DIR})

ENDIF(LMMS_BUILD_LINUX AND NOT WANT_VST_NOWINE)


ENDIF(LMMS_SUPPORT_VST)

=== plugins/vst_effect/CMakeLists.txt ===
IF(LMMS_SUPPORT_VST)
INCLUDE(BuildPlugin)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../vst_base)
LINK_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/../vst_base)
LINK_LIBRARIES(vstbase)

BUILD_PLUGIN(vsteffect VstEffect.cpp VstEffectControls.cpp VstEffectControlDialog.cpp VstSubPluginFeatures.cpp VstEffect.h VstEffectControls.h VstEffectControlDialog.h VstSubPluginFeatures.h MOCFILES VstEffectControls.h EMBEDDED_RESOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.png)

SET_TARGET_PROPERTIES(vsteffect PROPERTIES COMPILE_FLAGS "-Wno-attributes")

ENDIF(LMMS_SUPPORT_VST)

=== plugins/zynaddsubfx/CMakeLists.txt ===
IF(LMMS_HAVE_FFTW3F)

INCLUDE(BuildPlugin)

SET(ZYN_SRC_GUI
	${CMAKE_CURRENT_SOURCE_DIR}/src/UI/MasterUI.cc
	${CMAKE_CURRENT_SOURCE_DIR}/src/UI/VirKeyboard.cc
	${CMAKE_CURRENT_SOURCE_DIR}/src/UI/ConfigUI.cc
	${CMAKE_CURRENT_SOURCE_DIR}/src/UI/OscilGenUI.cc
	${CMAKE_CURRENT_SOURCE_DIR}/src/UI/WidgetPDial.cc
	${CMAKE_CURRENT_SOURCE_DIR}/src/UI/ResonanceUI.cc
	${CMAKE_CURRENT_SOURCE_DIR}/src/UI/MicrotonalUI.cc
	${CMAKE_CURRENT_SOURCE_DIR}/src/UI/ADnoteUI.cc
	${CMAKE_CURRENT_SOURCE_DIR}/src/UI/PresetsUI.cc
	${CMAKE_CURRENT_SOURCE_DIR}/src/UI/EffUI.cc
	${CMAKE_CURRENT_SOURCE_DIR}/src/UI/FilterUI.cc
	${CMAKE_CURRENT_SOURCE_DIR}/src/UI/PartUI.cc
	${CMAKE_CURRENT_SOURCE_DIR}/src/UI/EnvelopeUI.cc
	${CMAKE_CURRENT_SOURCE_DIR}/src/UI/LFOUI.cc
	${CMAKE_CURRENT_SOURCE_DIR}/src/UI/SeqUI.cc
	${CMAKE_CURRENT_SOURCE_DIR}/src/UI/PADnoteUI.cc
	${CMAKE_CURRENT_SOURCE_DIR}/src/UI/SUBnoteUI.cc
	${CMAKE_CURRENT_SOURCE_DIR}/src/UI/BankUI.cc
)


# definitions for ZynAddSubFX
IF(LMMS_BUILD_LINUX OR LMMS_BUILD_APPLE)
	ADD_DEFINITIONS(-DOS_LINUX)
ELSE(LMMS_BUILD_LINUX OR LMMS_BUILD_APPLE)
	ADD_DEFINITIONS(-DOS_WINDOWS)
ENDIF(LMMS_BUILD_LINUX OR LMMS_BUILD_APPLE)

# do not conflict with LMMS' Controller class
ADD_DEFINITIONS(-DController=ZynController)

# use asm optimizations when on x86 or x86_64
IF(LMMS_HOST_X86 OR LMMS_HOST_X86_64)
	ADD_DEFINITIONS(-DASM_F2I_YES)
ENDIF(LMMS_HOST_X86 OR LMMS_HOST_X86_64)

# build ZynAddSubFX with full optimizations
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2 -Wno-write-strings -Wno-deprecated-declarations")

# link system-libraries when on win32
IF(LMMS_BUILD_WIN32)
	ADD_DEFINITIONS(-DPTW32_STATIC_LIB)
ENDIF(LMMS_BUILD_WIN32)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/fltk/ ${CMAKE_CURRENT_SOURCE_DIR} ${FFTW3F_INCLUDE_DIRS} ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_BINARY_DIR} )

set(ZASF_CORE_LIBS
    zynaddsubfx_input
    zynaddsubfx_output
    zynaddsubfx_misc
    zynaddsubfx_synth
    zynaddsubfx_seq
    zynaddsubfx_effect
    zynaddsubfx_params
    zynaddsubfx_dsp
    zynaddsubfx_samples
    )

macro(unit_test NAME CXX_FILE FILES)
endmacro(unit_test)

add_subdirectory(src/Misc)
add_subdirectory(src/Input)
add_subdirectory(src/Synth)
add_subdirectory(src/Output)
add_subdirectory(src/Seq)
add_subdirectory(src/Effects)
add_subdirectory(src/Params)
add_subdirectory(src/DSP)
add_subdirectory(src/Samples)

ADD_LIBRARY(ZynAddSubFxCore SHARED LocalZynAddSubFx.cpp)
TARGET_LINK_LIBRARIES(ZynAddSubFxCore ${ZASF_CORE_LIBS} ${FFTW3F_LIBRARIES} ${QT_LIBRARIES} -lz -lpthread)
IF(LMMS_BUILD_WIN32)
	TARGET_LINK_LIBRARIES(ZynAddSubFxCore -lws2_32)
	INSTALL(TARGETS ZynAddSubFxCore RUNTIME DESTINATION ${PLUGIN_DIR})
ELSE(LMMS_BUILD_WIN32)
	INSTALL(TARGETS ZynAddSubFxCore LIBRARY DESTINATION ${PLUGIN_DIR})
ENDIF(LMMS_BUILD_WIN32)

BUILD_PLUGIN(zynaddsubfx ZynAddSubFx.cpp ZynAddSubFx.h MOCFILES ZynAddSubFx.h EMBEDDED_RESOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.png)
TARGET_LINK_LIBRARIES(zynaddsubfx ZynAddSubFxCore)

IF(WIN32)
	SET(WINRC "${CMAKE_CURRENT_BINARY_DIR}/zynaddsubfxrc.obj")
	ADD_CUSTOM_COMMAND(OUTPUT ${WINRC}
				COMMAND ${WINDRES}
					-I${CMAKE_CURRENT_SOURCE_DIR}
					-o${CMAKE_CURRENT_BINARY_DIR}/zynaddsubfxrc.obj
					-i${CMAKE_CURRENT_BINARY_DIR}/zynaddsubfx.rc
				DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/zynaddsubfx.rc)
ENDIF(WIN32)

SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${PLUGIN_DIR}")
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
ADD_EXECUTABLE(RemoteZynAddSubFx RemoteZynAddSubFx.cpp ${ZYN_SRC_GUI} ${WINRC})
INSTALL(TARGETS RemoteZynAddSubFx RUNTIME DESTINATION ${PLUGIN_DIR})
TARGET_LINK_LIBRARIES(RemoteZynAddSubFx -lpthread -L${CMAKE_CURRENT_BINARY_DIR} -lZynAddSubFxCore ${CMAKE_CURRENT_BINARY_DIR}/fltk/lib/libfltk.a)
ADD_DEPENDENCIES(RemoteZynAddSubFx ZynAddSubFxCore)

# link system libraries when on win32
IF(LMMS_BUILD_WIN32)
	TARGET_LINK_LIBRARIES(RemoteZynAddSubFx ${QT_LIBRARIES} -lole32 -luuid -lcomctl32 -lgdi32 -lws2_32)
ENDIF(LMMS_BUILD_WIN32)

# FLTK needs X
IF(LMMS_BUILD_LINUX)
	FIND_PACKAGE(X11)
	FIND_PACKAGE(Freetype)
	TARGET_LINK_LIBRARIES(RemoteZynAddSubFx -ldl ${X11_LIBRARIES} ${X11_Xft_LIB} ${X11_Xinerama_LIB} ${FREETYPE_LIBRARY} -lfontconfig)
ENDIF(LMMS_BUILD_LINUX)


IF(LMMS_BUILD_WIN32)
	ADD_CUSTOM_COMMAND(TARGET ZynAddSubFxCore POST_BUILD COMMAND ${STRIP} ${CMAKE_CURRENT_BINARY_DIR}/libZynAddSubFxCore.dll)
	ADD_CUSTOM_COMMAND(TARGET RemoteZynAddSubFx POST_BUILD COMMAND ${STRIP} ${CMAKE_CURRENT_BINARY_DIR}/RemoteZynAddSubFx.exe)
ENDIF(LMMS_BUILD_WIN32)

# build FLTK
IF(LMMS_BUILD_WIN64)
	SET(FLTK_EXTRA_FLAGS "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_SOURCE_DIR}/cmake/modules/Win64Toolchain.cmake")
ELSEIF(LMMS_BUILD_WIN32)
	SET(FLTK_EXTRA_FLAGS "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_SOURCE_DIR}/cmake/modules/Win32Toolchain.cmake")
ENDIF(LMMS_BUILD_WIN64)
ADD_CUSTOM_TARGET(libfltk COMMAND mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/fltk && cd ${CMAKE_CURRENT_BINARY_DIR}/fltk && ${CMAKE_COMMAND} ${CMAKE_CURRENT_SOURCE_DIR}/fltk ${FLTK_EXTRA_FLAGS} -DCMAKE_MODULE_PATH=${CMAKE_SOURCE_DIR}/cmake/modules/ -DFLTK_USE_SYSTEM_ZLIB:BOOL=ON -DFLTK_USE_SYSTEM_JPEG:BOOL=ON -DFLTK_USE_SYSTEM_PNG:BOOL=ON -DOPTION_BUILD_EXAMPLES:BOOL=OFF -DCMAKE_BUILD_TYPE=release && ${CMAKE_BUILD_TOOL})

ADD_DEPENDENCIES(RemoteZynAddSubFx libfltk)
ENDIF(LMMS_HAVE_FFTW3F)

=== plugins/ladspa_effect/swh/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/include ${CMAKE_CURRENT_SOURCE_DIR})

ADD_DEFINITIONS(-DFFTW3)
IF(LMMS_HAVE_FFTW3F)
INCLUDE_DIRECTORIES(${FFTW3F_INCLUDE_DIRS})
LINK_DIRECTORIES(${FFTW3F_LIBRARY_DIRS})
LINK_LIBRARIES(-lfftw3f)
ENDIF(LMMS_HAVE_FFTW3F)
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR})

FILE(GLOB PLUGIN_SOURCES *.c)
FOREACH(_item ${PLUGIN_SOURCES})
	GET_FILENAME_COMPONENT(_plugin "${_item}" NAME_WE)
	IF(NOT "${_plugin}" STREQUAL "mbeq_1197" OR LMMS_HAVE_FFTW3F)
		ADD_LIBRARY(${_plugin} MODULE ${_item})
		INSTALL(TARGETS ${_plugin} LIBRARY DESTINATION ${PLUGIN_DIR}/ladspa)
		SET_TARGET_PROPERTIES(${_plugin} PROPERTIES PREFIX "")
		SET_TARGET_PROPERTIES(${_plugin} PROPERTIES COMPILE_FLAGS "-O3 -Wall -fomit-frame-pointer -fstrength-reduce -funroll-loops -ffast-math -c -fno-strict-aliasing")
		IF(LMMS_BUILD_WIN32)
			ADD_CUSTOM_COMMAND(TARGET ${_plugin} POST_BUILD COMMAND ${STRIP} ${CMAKE_CURRENT_BINARY_DIR}/${_plugin}.dll)
		ELSE(LMMS_BUILD_WIN32)
			SET_TARGET_PROPERTIES(${_plugin} PROPERTIES COMPILE_FLAGS "${COMPILE_FLAGS} -fPIC -DPIC")
		ENDIF(LMMS_BUILD_WIN32)
		IF(LMMS_BUILD_APPLE)
			SET_TARGET_PROPERTIES(${_plugin} PROPERTIES LINK_FLAGS "${LINK_FLAGS} -Bsymbolic -lm")
		ELSE(LMMS_BUILD_APPLE)
			SET_TARGET_PROPERTIES(${_plugin} PROPERTIES LINK_FLAGS "${LINK_FLAGS} -shared -Wl,-no-undefined -Wl,-Bsymbolic -lm")
		ENDIF(LMMS_BUILD_APPLE)
		IF(LMMS_BUILD_LINUX)
			SET_TARGET_PROPERTIES(${_plugin} PROPERTIES LINK_FLAGS "${LINK_FLAGS} -nostartfiles")
		ENDIF(LMMS_BUILD_LINUX)
	ENDIF(NOT "${_plugin}" STREQUAL "mbeq_1197" OR LMMS_HAVE_FFTW3F)
ENDFOREACH(_item ${PLUGIN_SOURCES})

=== debian/changelog ===
lmms (0.4.10-2ubuntu1.1) precise-proposed; urgency=low

  * Backported changes from 13.04's packaging:
    - installed desktop file so that the program is noticeable to users
      (LP: #863366);
    - adjusted versioned dependency on -common so that package upgrades
      can succeed (LP: #1152807).

 -- Daniel T Chen <crimsun@ubuntu.com>  Thu, 25 Apr 2013 11:16:48 -0400

lmms (0.4.10-2ubuntu1) precise; urgency=low

  * debian/control:
    - Build with wine1.4-dev (LP: #925127)
    - Remove manual wine dependency, obtain it via dh_shlibdeps
    - Remove wine and gcc-multilib build dependencies on amd64
      (package does not build with 64-bit only wine)
  * Merge from debian unstable.  Remaining changes:
    - Build with wine1.4-dev instead of libwine-dev
    - Remove manual wine dependency, obtain it via dh_shlibdeps
    - Remove wine and gcc-multilib build dependencies on amd64

 -- Scott Ritchie <scottritchie@ubuntu.com>  Sat, 25 Feb 2012 00:45:55 -0800

lmms (0.4.10-2) unstable; urgency=low

  * Removed build-dep on libestools2.0-dev (Closes: #614975)

 -- Patrick Winnertz <winnie@debian.org>  Fri, 11 Mar 2011 09:37:43 +0100

lmms (0.4.10-1ubuntu3) oneiric; urgency=low

  * Rebuild for fluidsynth 1.1.4 (LP: #821346)

 -- Alessio Treglia <quadrispro@ubuntu.com>  Fri, 05 Aug 2011 17:00:23 +0200

lmms (0.4.10-1ubuntu2) natty; urgency=low

  * Replace obsolete wine-bin dependency with wine1.2 (LP: #696189).

 -- Артём Попов <artfwo@gmail.com>  Tue, 15 Feb 2011 20:29:59 +0600

lmms (0.4.10-1ubuntu1) natty; urgency=low

  * Merge from debian unstable (LP: #718801).  Remaining changes:
    - Replace build-dep on libwine-dev with wine1.2-dev to build
      against the newer Wine.

 -- Артём Попов <artfwo@gmail.com>  Mon, 14 Feb 2011 20:58:36 +0600

lmms (0.4.10-1) unstable; urgency=low

  * Imported Upstream version 0.4.10
  * changed mode of patch
  * Add source/format with 3.0 (quilt) and rearrange source a bit
  * Bump standarts version to 3.9.1 - no further changes needed

 -- Patrick Winnertz <winnie@debian.org>  Fri, 11 Feb 2011 20:03:06 +0100

lmms (0.4.7-2ubuntu2) natty; urgency=low

  * Rebuild, don't install libs in /usr/lib64.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 04 Jan 2011 12:17:01 +0100

lmms (0.4.7-2ubuntu1) natty; urgency=low

  * Re-sync with Debian (LP: #606533):
    - Replace build-dep on libwine-dev with libwine-dev-unstable to build
      against the newer Wine.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Fri, 12 Nov 2010 13:32:32 +0100

lmms (0.4.7-2) unstable; urgency=low
  
  [ Reinhard Tartler ]
  * Depend on wine only on i386 and amd64 (Closes: #590950)

  [ Patrick Winnertz ]
  * Uploading patch from siretart, thanks for helping.

 -- Patrick Winnertz <winnie@debian.org>  Mon, 02 Aug 2010 10:13:28 +0200

lmms (0.4.7-1) unstable; urgency=low

  * New upstream version

 -- Patrick Winnertz <winnie@debian.org>  Thu, 29 Jul 2010 16:24:00 +0200

lmms (0.4.6-2) unstable; urgency=low

  * Build-depend on libestools2.0-dev (Closes: #589882)

 -- Patrick Winnertz <winnie@debian.org>  Wed, 28 Jul 2010 11:55:16 +0200

lmms (0.4.6-1) unstable; urgency=low

  * New upstream version (Closes: #565733)
  * Bumped standards version to 3.8.3, no further changes needed

 -- Patrick Winnertz <winnie@debian.org>  Sun, 24 Jan 2010 16:40:39 +0100

lmms (0.4.5-1) unstable; urgency=low

  * New upstream version (Closes: #543645)
  * Fix FTBFS on amd64 (Closes: #540671 #543017)

 -- Patrick Winnertz <winnie@debian.org>  Fri, 11 Sep 2009 09:56:45 +0200

lmms (0.4.4-1) unstable; urgency=low

  * New upstream version (Closes: #511363)
  * Provide menu file (Closes: #514905)
    - The menufile is included in lmms-common and not in lmms 
      as it is not arch specific
  * Bumped standards version to 3.8.2 no further changes needed

 -- Patrick Winnertz <winnie@debian.org>  Wed, 05 Aug 2009 20:46:40 +0200

lmms (0.3.2-1) unstable; urgency=low

  * Decrease wine dependency to wine-bin as suggested. (Closes: #446163)
  * Acknowlegded NMU from Pierre Habouzit <madcoder@debian.org> in order to
    fix FTBFS with gcc-4.3 which (Closes: #462202)
  * Now including the singerbot plugin. (Closes: #443224)
  * Add patch to prevent lmms from crashing.

 -- Patrick Winnertz <winnie@debian.org>  Mon, 17 Mar 2008 10:56:12 +0100

lmms (0.3.1-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Add g++-4.3.patch to fix g++-4.3 FTBFS (Closes: 462202).

 -- Pierre Habouzit <madcoder@debian.org>  Sun, 16 Mar 2008 23:21:56 +0000

lmms (0.3.1-1) unstable; urgency=low

  * Packaging new upstream release.
  * Install Upstream Changelog (Closes: #441477)
    Thanks to Felipe Sateler
  * Lowered the caps dependency to Recommends (Closes: #446163)
  * Added -i/-a to the build targets in rules in order to make sure that only
    (in)dep packages are build.
  * Changed my maintainer address
  * Added patch to remove stereo_enhancer plugin which has a ftbfs with gcc
    4.2.3
  * Added imagemagick as build-dep since we have to convert a .png to a .xpm
    via convert
  * Doesn't install upstreams menu file, since it's outdated.. instead use
    our own.
  * Standard-Version bump to 3.7.3
  * Remove Homepage field from Description and create a own Header
  * Added postinst and postrm for lmms-common to call update-menu if available
    (this has to be done manually, since we doesn't use dh_installmenu to install
    the menu file)

 -- Patrick Winnertz <winnie@debian.org>  Thu, 06 Dec 2007 07:08:04 +0100

lmms (0.3.0-1) unstable; urgency=low

  [ Tobias Doerffel ]
  * New upstream release. (Closes: #439301)
  * Removed patch from Thomas Girard as upstream merged changes

  [ Patrick Winnertz ]
  * Moved manpage into correct package (lmms)
  * Removed manuall installation of Upstream Changelog, thanks to the power of
    debhelper ;-)
  * FTBFS with gcc 4.2 is fixed by upstream (Closes: #383295)
  * lmms has now a proper menu entry (Closes: #383406)


=== debian/control ===
Source: lmms
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Patrick Winnertz <winnie@debian.org>
Build-Depends: debhelper (>= 5.0.0), libsdl-sound1.2-dev, libsamplerate0-dev, libsndfile1-dev, libvorbis-dev, libjack-dev, libstk0-dev, ladspa-sdk, libflac-dev, wine1.4-dev [i386], libasound2-dev, festival-dev, imagemagick, cmake, qt4-qmake, libqt4-dev, libpulse-dev, libfluidsynth-dev, libfftw3-dev, libfreetype6-dev, libxft-dev, portaudio19-dev, libxinerama-dev
Standards-Version: 3.9.1
Homepage: http://lmms.sf.net/

Package: lmms
Architecture: any
Depends: lmms-common (>= ${source:Version}) , ${shlibs:Depends}, ${misc:Depends}, stk
Recommends: tap-plugins, caps
Suggests: fil-plugins, mcp-plugins, omins, vcf, freepats
Description: Linux Multimedia Studio
 LMMS aims to be a free alternative to popular (but commercial and closed-
 source) programs like FruityLoops, Cubase and Logic giving you the ability of
 producing music with your computer by creating cool loops, synthesizing and
 mixing sounds, arranging samples, having more fun with your MIDI-keyboard
 and much more...
 .
 LMMS combines the features of a tracker-/sequencer-program (pattern-/channel-/
 sample-/song-/effect-management) and those of powerful synthesizers and
 samplers in a modern, user-friendly and easy to use graphical user-interface.

Package: lmms-common
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Linux Multimedia Studio - common files
 LMMS aims to be a free alternative to popular (but commercial and closed-
 source) programs like FruityLoops, Cubase and Logic giving you the ability of
 producing music with your computer by creating cool loops, synthesizing and
 mixing sounds, arranging samples, having more fun with your MIDI-keyboard
 and much more...
 .
 LMMS combines the features of a tracker-/sequencer-program (pattern-/channel-/
 sample-/song-/effect-management) and those of powerful synthesizers and
 samplers in a modern, user-friendly and easy to use graphical user-interface.
 .
 This package contains the platform independent files such as samples, presets
 and some example projects.

=== debian/rules ===
#!/usr/bin/make -f

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

debian/lmms.xpm: data/themes/default/icon.png
	convert -resize 32 $< $@


config.status: configure patch-stamp
	dh_testdir
	touch ./configure
	
build: build-stamp
build-stamp: patch-stamp config.status
	dh_testdir
	cmake . -DCMAKE_INSTALL_PREFIX=/usr
	touch build-stamp

clean: unpatch
	dh_testdir
	dh_testroot
	rm -f build-stamp 
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -f config.log
	dh_clean 


install: build debian/lmms.xpm
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs
	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp
	install -D -m 644 debian/lmms.xpm debian/lmms-common/usr/share/pixmaps/lmms.xpm
	install -D -m 644 debian/menu debian/lmms-common/usr/share/menu/lmms
	dh_install --sourcedir=$(CURDIR)/debian/tmp
	dh_installdirs

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir -i 
	dh_testroot -i
	dh_installchangelogs -i 
	dh_installdocs -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs -a
	dh_installdocs -a
	dh_installman -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

patch: patch-stamp
patch-stamp:


patch: patch-stamp
patch-stamp:
	touch $@

unpatch:
	rm -rf debian/patched patch-stamp

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## lmms 0.4.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 SET(VERSION_MAJOR "0")
 SET(VERSION_MINOR "4")
-SET(VERSION_PATCH "10")
+SET(VERSION_PATCH "13")
 #SET(VERSION_SUFFIX "")
 SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
 IF(VERSION_SUFFIX)
@@ -322,7 +322,7 @@
 
 # check for libsamplerate
 IF(WANT_SYSTEM_SR)
-	PKG_CHECK_MODULES(SAMPLERATE samplerate>=0.1.7)
+	PKG_CHECK_MODULES(SAMPLERATE samplerate>=0.1.8)
 	IF(SAMPLERATE_FOUND)
 		SET(LMMS_HAVE_SAMPLERATE TRUE)
 	ENDIF(SAMPLERATE_FOUND)

=== plugins/vst_base/CMakeLists.txt ===
--- 
+++ 
@@ -4,8 +4,8 @@
 
 IF(LMMS_BUILD_WIN32)
 	ADD_DEFINITIONS(-DPTW32_STATIC_LIB)
-	LINK_LIBRARIES(-lQtCore4 -lpthread -lgdi32 -lws2_32)
 	ADD_EXECUTABLE(RemoteVstPlugin ${CMAKE_CURRENT_SOURCE_DIR}/RemoteVstPlugin.cpp)
+	TARGET_LINK_LIBRARIES(RemoteVstPlugin -lQtCore4 -lpthread -lgdi32 -lws2_32)
 	ADD_CUSTOM_COMMAND(TARGET RemoteVstPlugin POST_BUILD COMMAND ${STRIP} ${CMAKE_CURRENT_BINARY_DIR}/RemoteVstPlugin.exe)
 	INSTALL(TARGETS RemoteVstPlugin RUNTIME DESTINATION ${PLUGIN_DIR})

=== plugins/ladspa_effect/swh/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 ENDIF(LMMS_HAVE_FFTW3F)
 INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR})
 
-FILE(GLOB PLUGIN_SOURCES *.c)
+FILE(GLOB PLUGIN_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.c)
 FOREACH(_item ${PLUGIN_SOURCES})
 	GET_FILENAME_COMPONENT(_plugin "${_item}" NAME_WE)
 	IF(NOT "${_plugin}" STREQUAL "mbeq_1197" OR LMMS_HAVE_FFTW3F)
@@ -32,3 +32,41 @@
 	ENDIF(NOT "${_plugin}" STREQUAL "mbeq_1197" OR LMMS_HAVE_FFTW3F)
 ENDFOREACH(_item ${PLUGIN_SOURCES})
 
+
+ADD_LIBRARY(iir STATIC util/iir.c)
+SET_TARGET_PROPERTIES(iir PROPERTIES COMPILE_FLAGS "-fPIC")
+TARGET_LINK_LIBRARIES(bandpass_a_iir_1893 iir)
+TARGET_LINK_LIBRARIES(bandpass_iir_1892 iir)
+TARGET_LINK_LIBRARIES(butterworth_1902 iir)
+TARGET_LINK_LIBRARIES(highpass_iir_1890 iir)
+TARGET_LINK_LIBRARIES(lowpass_iir_1891 iir)
+TARGET_LINK_LIBRARIES(notch_iir_1894 iir)
+
+FILE(GLOB GSM_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/gsm/*.c)
+ADD_LIBRARY(gsm STATIC ${GSM_SOURCES})
+SET_TARGET_PROPERTIES(gsm PROPERTIES COMPILE_FLAGS "-fPIC")
+TARGET_LINK_LIBRARIES(gsm_1215 gsm)
+
+ADD_LIBRARY(gverb STATIC gverb/gverb.c gverb/gverbdsp.c)
+SET_TARGET_PROPERTIES(gverb PROPERTIES COMPILE_FLAGS "-fPIC")
+TARGET_LINK_LIBRARIES(gverb_1216 gverb)
+
+ADD_LIBRARY(blo STATIC util/blo.c)
+SET_TARGET_PROPERTIES(blo PROPERTIES COMPILE_FLAGS "-fPIC")
+TARGET_LINK_LIBRARIES(hermes_filter_1200 blo)
+
+ADD_LIBRARY(rms STATIC util/rms.c)
+ADD_LIBRARY(db STATIC util/db.c)
+SET_TARGET_PROPERTIES(rms PROPERTIES COMPILE_FLAGS "-fPIC")
+SET_TARGET_PROPERTIES(db PROPERTIES COMPILE_FLAGS "-fPIC")
+TARGET_LINK_LIBRARIES(sc1_1425 rms db)
+TARGET_LINK_LIBRARIES(sc2_1426 rms db)
+TARGET_LINK_LIBRARIES(sc3_1427 rms db)
+TARGET_LINK_LIBRARIES(sc4_1882 rms db)
+TARGET_LINK_LIBRARIES(sc4m_1916 rms db)
+TARGET_LINK_LIBRARIES(se4_1883 rms db)
+
+ADD_LIBRARY(pitchscale STATIC util/pitchscale.c)
+SET_TARGET_PROPERTIES(pitchscale PROPERTIES COMPILE_FLAGS "-fPIC")
+TARGET_LINK_LIBRARIES(pitch_scale_1193 pitchscale)
+TARGET_LINK_LIBRARIES(pitch_scale_1194 pitchscale)

=== plugins/vst_base/Win64/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR}/include)
SET(CMAKE_CXX_COMPILER "${CMAKE_CXX_COMPILER32}")

ADD_EXECUTABLE(RemoteVstPlugin32 ${CMAKE_CURRENT_SOURCE_DIR}/../RemoteVstPlugin.cpp)
TARGET_LINK_LIBRARIES(RemoteVstPlugin32 -lQtCore4 -lpthread -lgdi32 -lws2_32)

ADD_CUSTOM_COMMAND(TARGET RemoteVstPlugin32 POST_BUILD COMMAND ${STRIP} ${CMAKE_CURRENT_BINARY_DIR}/RemoteVstPlugin32.exe)

INSTALL(TARGETS RemoteVstPlugin32 RUNTIME DESTINATION ${PLUGIN_DIR}/32)

INSTALL(FILES
				${MINGW_PREFIX32}/bin/QtCore4.dll
				${MINGW_PREFIX32}/bin/zlib1.dll
			DESTINATION ${PLUGIN_DIR}/32)

=== debian/changelog ===
lmms (0.4.13-0ubuntu1) raring; urgency=low

  * New  Upstream release.
    - Minor tweaking to ZynAddSubFX, CALF, SWH plugins  and Stefan Fendt's RC
      filters.
    - Added UI fixes: Magnentic effect of knobs and Piano-roll fixes
    - Updated German localization and copyright year
  * debian/lmms-common.install:
    - added /usr/share/applications so the lmms.desktop file will correctly
      install (LP: #863366)
    - This should also fix the Software Center not displaying lmms in sound
      and video (LP: #824231)

 -- Israel Dahl <israeldahl@gmail.com>  Tue, 04 Dec 2012 06:36:06 -0600

lmms (0.4.10-2.3ubuntu1) quantal; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Build with wine1.4-dev (LP: #925127)
    - Remove manual wine dependency, obtain it via dh_shlibdeps
    - Remove wine and gcc-multilib build dependencies on amd64
      (package does not build with 64-bit only wine)

 -- Julian Taylor <jtaylor@ubuntu.com>  Mon, 01 Oct 2012 20:30:17 +0200

lmms (0.4.10-2.3) unstable; urgency=low

  * Non maintainer upload.
  * Remove wine-related dependencies on amd64, thereby disabling building
    VST plugin. (Closes: #676760)

 -- Hilko Bengen <bengen@debian.org>  Wed, 27 Jun 2012 23:14:40 +0200

lmms (0.4.10-2.2) unstable; urgency=low

  * Non maintainer upload.
  * Fix build failure with GCC 4.7. Closes: #667265.
  * Turn on verbose build.

 -- Matthias Klose <doko@debian.org>  Tue, 17 Apr 2012 14:08:53 +0200

lmms (0.4.10-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix FTBFS on GNU/kFreeBSD. Thanks Pino Toscano.  (Closes: #641064)

 -- Robert Millan <rmh@debian.org>  Fri, 27 Apr 2012 22:55:55 +0200

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,13 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Patrick Winnertz <winnie@debian.org>
-Build-Depends: debhelper (>= 5.0.0), libsdl-sound1.2-dev, libsamplerate0-dev, libsndfile1-dev, libvorbis-dev, libjack-dev, libstk0-dev, ladspa-sdk, libflac-dev, wine1.4-dev [i386], libasound2-dev, festival-dev, imagemagick, cmake, qt4-qmake, libqt4-dev, libpulse-dev, libfluidsynth-dev, libfftw3-dev, libfreetype6-dev, libxft-dev, portaudio19-dev, libxinerama-dev
+Build-Depends: debhelper (>= 5.0.0), libsdl-sound1.2-dev, libsamplerate0-dev, libsndfile1-dev, libvorbis-dev, libjack-dev, libstk0-dev, ladspa-sdk, libflac-dev, wine1.4-dev [i386], libasound2-dev [linux-any], festival-dev, imagemagick, cmake, qt4-qmake, libqt4-dev, libpulse-dev, libfluidsynth-dev, libfftw3-dev, libfreetype6-dev, libxft-dev, portaudio19-dev, libxinerama-dev
 Standards-Version: 3.9.1
 Homepage: http://lmms.sf.net/
 
 Package: lmms
 Architecture: any
-Depends: lmms-common (>= ${source:Version}) , ${shlibs:Depends}, ${misc:Depends}, stk
+Depends: lmms-common (= ${source:Version}) , ${shlibs:Depends}, ${misc:Depends}, stk
 Recommends: tap-plugins, caps
 Suggests: fil-plugins, mcp-plugins, omins, vcf, freepats
 Description: Linux Multimedia Studio

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,13 @@
 # from having to guess our platform (since we know it already)
 DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
+
+DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
+
+EXTRA_CMAKE_ARGS :=
+ifneq ($(DEB_HOST_ARCH_OS),linux)
+	EXTRA_CMAKE_ARGS += -DWANT_ALSA:BOOL=OFF
+endif
 
 
 CFLAGS = -Wall -g
@@ -25,7 +32,7 @@
 build: build-stamp
 build-stamp: patch-stamp config.status
 	dh_testdir
-	cmake . -DCMAKE_INSTALL_PREFIX=/usr
+	cmake . -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_VERBOSE_MAKEFILE=1 $(EXTRA_CMAKE_ARGS)
 	touch build-stamp
 
 clean: unpatch

=== debian/watch ===
version=3
http://sf.net/lmms/lmms-(.*)\.tar\.bz2

## lmms 0.4.14

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,8 +15,8 @@
 
 SET(VERSION_MAJOR "0")
 SET(VERSION_MINOR "4")
-SET(VERSION_PATCH "13")
-#SET(VERSION_SUFFIX "")
+SET(VERSION_PATCH "14")
+SET(VERSION_SUFFIX "rc1")
 SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
 IF(VERSION_SUFFIX)
 	SET(VERSION "${VERSION}-${VERSION_SUFFIX}")
@@ -30,7 +30,6 @@
 OPTION(WANT_CALF	"Include CALF LADSPA plugins" ON)
 OPTION(WANT_CAPS	"Include C* Audio Plugin Suite (LADSPA plugins)" ON)
 OPTION(WANT_CMT		"Include Computer Music Toolkit LADSPA plugins" ON)
-OPTION(WANT_FFTW3F	"Include SpectrumAnalyzer and ZynAddSubFX plugin" ON)
 OPTION(WANT_JACK	"Include JACK (Jack Audio Connection Kit) support" ON)
 OPTION(WANT_OGGVORBIS	"Include OGG/Vorbis support" ON)
 OPTION(WANT_PULSEAUDIO	"Include PulseAudio support" ON)
@@ -261,16 +260,7 @@
 
 
 # check for FFTW3F-library
-IF(WANT_FFTW3F)
-	PKG_CHECK_MODULES(FFTW3F fftw3f>=3.0.0)
-	IF(FFTW3F_FOUND)
-		SET(LMMS_HAVE_FFTW3F TRUE)
-		SET(STATUS_FFTW3F "OK")
-	ELSE(FFTW3F_FOUND)
-		SET(STATUS_FFTW3F "not found, libfftw3-dev (or similiar) "
-			"is highly recommended")
-	ENDIF(FFTW3F_FOUND)
-ENDIF(WANT_FFTW3F)
+PKG_CHECK_MODULES(FFTW3F REQUIRED fftw3f>=3.0.0)
 
 
 # check for Fluidsynth
@@ -366,3 +356,15 @@
 
 FILE(GLOB lmms_INCLUDES ${CMAKE_SOURCE_DIR}/include/*.h)
 FILE(GLOB lmms_UI ${CMAKE_SOURCE_DIR}/src/gui/dialogs/*.ui ${CMAKE_SOURCE_DIR}/src/gui/Forms/*.ui)
+FILE(GLOB_RECURSE lmms_SOURCES ${CMAKE_SOURCE_DIR}/src/*.cpp)
+
+SET(lmms_MOC ${lmms_INCLUDES})
+
+SET(lmms_EMBEDDED_RESOURCES ${CMAKE_SOURCE_DIR}/AUTHORS ${CMAKE_SOURCE_DIR}/COPYING)
+
+QT4_WRAP_CPP(lmms_MOC_out ${lmms_MOC} OPTIONS -nw)
+QT4_WRAP_UI(lmms_UI_out ${lmms_UI})
+
+
+# embedded resources stuff
+IF(WIN32 OR WIN64)

=== debian/changelog ===
lmms (0.4.14-0ubuntu3) raring; urgency=low

  * Make lmms depend on lmms-common (>= ${source:Version}) instead of 
    only = to fix (LP: #1152807)

 -- Howard Chan <smartboyhw@gmail.com>  Sun, 10 Mar 2013 15:21:43 +0800

lmms (0.4.14-0ubuntu2) raring; urgency=low

  * Readded lib64-builddir.patch to fix FTBFS on amd64.

 -- Daniel T Chen <crimsun@ubuntu.com>  Wed, 06 Mar 2013 13:01:25 -0500

lmms (0.4.14-0ubuntu1) raring; urgency=low

  * New upstream release.
    - Graphically enhanced AudioFileProcessor plugin
    - Fixed bug with magnetic knobs
    - Fixed various crashes
    - Completely revised VST support (improved VST effect support,
    timesync support and many more)
    - Added multitrack export
    - Added Hydrogen song import plugin
    - Fixed wrong chords
    - Improvements to automation framework
  * debian/lmms.install debian/lmms-common.install
    - moved /usr/share/applications to lmms.install
  * debian/control
    - updated Standards-Version to 3.9.4
  * debian/copyright
    - updated to make current
  * debian/rules
    - fixed Lintian errors during build

 -- Israel Dahl <israeldahl@gmail.com>  Thu, 28 Feb 2013 20:58:18 -0600

=== debian/control ===
--- 
+++ 
@@ -4,12 +4,12 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Patrick Winnertz <winnie@debian.org>
 Build-Depends: debhelper (>= 5.0.0), libsdl-sound1.2-dev, libsamplerate0-dev, libsndfile1-dev, libvorbis-dev, libjack-dev, libstk0-dev, ladspa-sdk, libflac-dev, wine1.4-dev [i386], libasound2-dev [linux-any], festival-dev, imagemagick, cmake, qt4-qmake, libqt4-dev, libpulse-dev, libfluidsynth-dev, libfftw3-dev, libfreetype6-dev, libxft-dev, portaudio19-dev, libxinerama-dev
-Standards-Version: 3.9.1
+Standards-Version: 3.9.4
 Homepage: http://lmms.sf.net/
 
 Package: lmms
 Architecture: any
-Depends: lmms-common (= ${source:Version}) , ${shlibs:Depends}, ${misc:Depends}, stk
+Depends: lmms-common (>= ${source:Version}) , ${shlibs:Depends}, ${misc:Depends}, stk
 Recommends: tap-plugins, caps
 Suggests: fil-plugins, mcp-plugins, omins, vcf, freepats
 Description: Linux Multimedia Studio
